  /*! \file libStrings.cc   
 * \brief  fonction commune  l'extraction des 	
 *         squences genbank et EMBL            
 *    				                
 * @date created 23 Oct 2005
 * \date Last Modified : Time-stamp: <2005-10-26 09:46:22 lucas>
 * \note Copyright:    Groupe Epissage CGM-Gif France
 */


#include <string>
#include <ctype.h>
#include "libStrings.h"
#include "libIndex.h"
namespace libStrings{



  /* ---------------------------------------------------- */
  /* @Function: SupprimerSeparateurs	                */
  /** @brief  Supprime tous les separateurs de  *src   
   *  Retourne la longueur de *dest                       */
  /* ---------------------------------------------------- */
  
  int SupprimerSeparateurs(char *src, char *dest)
  {
    int ls, i, k = 0;
    
    ls = strlen(src);
    for(i = 0; i < ls; i++)
      if(isalnum(src[i]))
	dest[k++] = src[i];
    dest[k] = '\0';
    return(k);
    /*    return strlen(dest); */
  } 



  /* ---------------------------------------------------- */
  /* @Function: EstFinLigne                               */
  /** @brief  Renvoie Vrai si le caractere "c" est       
   *    un retour chariot ou un line feed              */
  /* ---------------------------------------------------- */
  int EstFinLigne(char c)
  {
    return (c == '\n') || (c == '\r');
  }
  


  /** \brief put characters from A to z from str into
   * seq (address of final sequence), not more than maxi 
   * (exclude space and numbers).
   * \param from position from buffer to begin write.
   * \param str character string (input)
   * \param seq sequence (destination: character string)
   * \param maxi in fact: size allowed for bufno !
   */
  int Pousse_atgc (int from,char *str, char  *seq, int maxi) 
  {
    int k = 0;
    char *s;
    /*  k = strlen(buffie); */
    k = from;
    if (! str)
      return -1;

    /* If we are far from the end... 
     * we will not check the end at each char
     */
    if(k < (maxi-120))
      for (s = str ; *s ; s++)
	{
	  if(isalpha(*s))
	    seq[k++] = *s;
	}
    else
      for (s = str ;( *s && (k<maxi)) ; s++)
	if(isalpha(*s))
	  seq[k++] = *s;

    seq[k] = '\0';

    return(k);

}

#define IS_LOWER(c) (((c) >= 'a') && ((c) <= 'z'))
#define TO_UPPER(c) ((c) - 'a' + 'A')

  /* ---------------------------------------------------- */
  /* @Function: sys_upper_string				*/
  /** @brief  uppercase string 'str' 			*/
  /* ---------------------------------------------------- */
  void sys_upper_string(char *str)
  {
    char *s;
    
    if (! str)
      return;
    
    for (s = str ; *s ; s++)
      if (IS_LOWER(*s))
	*s = TO_UPPER(*s);
  }

#undef IS_LOWER
#undef TO_UPPER





}
